'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var tslib = require('tslib');
var React = require('react');
var router = require('next/router');
var rosetta = require('rosetta');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var rosetta__default = /*#__PURE__*/_interopDefaultLegacy(rosetta);

var I18nContext = React.createContext(null);
function useI18n() {
    var instance = React.useContext(I18nContext);
    if (!instance) {
        throw new Error("There was an error getting i18n instance from context");
    }
    return instance;
}
function I18nProvider(_a) {
    var table = _a.table, props = tslib.__rest(_a, ["table"]);
    var locale = router.useRouter().locale;
    var _b = React.useState(function () {
        // Initial state
        var current = rosetta__default['default']();
        // const current = rosettaExtended<T>();
        current.set(locale, table);
        current.locale(locale);
        return current;
    }), i18n = _b[0], setI18n = _b[1];
    var hasChanged = i18n.locale() !== locale;
    React.useEffect(function () {
        var current = rosetta__default['default']();
        current.set(locale, table);
        current.locale(locale);
        setI18n(current);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [hasChanged, table]);
    return React__default['default'].createElement(I18nContext.Provider, tslib.__assign({ value: i18n }, props));
}

exports.I18nContext = I18nContext;
exports.I18nProvider = I18nProvider;
exports.useI18n = useI18n;
//# sourceMappingURL=next-rosetta.js.map
