import React from "react";
import { Rosetta as RosettaBase } from "rosetta";
declare type Key = string | number | bigint | symbol;
/**
 * @see https://github.com/microsoft/TypeScript/pull/40336
 */
declare type PropType<T, Path extends Key> = string extends Path ? unknown : Path extends keyof T ? T[Path] : Path extends `${infer K}.${infer R}` ? K extends keyof T ? PropType<T[K], R> : unknown : unknown;
declare type Join<T extends unknown[], D extends string> = T extends [] ? "" : T extends [string | number | boolean | bigint] ? `${T[0]}` : T extends [string | number | boolean | bigint, ...infer U] ? `${T[0]}${D}${Join<U, D>}` : string;
export interface RosettaExtended<T> extends Omit<RosettaBase<T>, "t"> {
    t<P extends Key | Key[], X extends Record<string, any> | any[]>(key: P, params?: X, lang?: string): P extends Key[] ? PropType<T, Join<P, ".">> : P extends Key ? PropType<T, P> : unknown;
}
export declare const I18nContext: React.Context<RosettaExtended<any> | null>;
export declare function useI18n<T = any>(): RosettaExtended<T>;
export declare type I18nProps<T = any> = {
    table: T;
};
export declare type I18nProviderProps<T = any> = I18nProps<T> & {
    children?: any;
};
export declare function I18nProvider<T = any>({ table, ...props }: I18nProviderProps<T>): JSX.Element;
export {};
